reqSpec = new RequirementSpecTool(issues)

/**
 * Velocity tool to sort the requirements by their headings, like "1.1", "2.45.6" and so.
 * Please note that both numeric and alphatetic sorting would fail with these.
 */
class RequirementSpecTool {
	public static final int MAX_HEADING_SECTION_WIDTH = 10
	public static final int MAX_HEADING_DEPTH = 10
	public static final String REALLY_BIG_HEADING = "9" * MAX_HEADING_SECTION_WIDTH * MAX_HEADING_DEPTH

	def issues

	RequirementSpecTool(issues) {
		this.issues = issues
	}

	def issuesSortedByHeading(headingNumberCustomFieldId) {
		def headingNumberCustomFieldName = "customfield_${headingNumberCustomFieldId}"
		def normalizedHeading = { s -> s?.tokenize(".")*.padLeft(MAX_HEADING_SECTION_WIDTH, "0")?.join() ?: REALLY_BIG_HEADING }
		def issueHeading = { issue -> normalizedHeading(issue.getCustomFieldValue(headingNumberCustomFieldName)) }
		return issues.sort { a, b -> issueHeading(a) <=> issueHeading(b) } // keeps original order if heading is missing or equal
	}
}
